<?php if ( ! defined( 'ABSPATH' ) ) {exit;}?>
<div class="tab-pane" id="ContentF">
    <form method="post" action="<?php echo '//' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']; ?>">
    <div class="col-lg-12">
        <h3><?php _e("Block IPs manually","wpinfecscan");?></h3>
        <p><?php _e("Enter one IP per line in the below column which you want to block from access to the entire website, then press [Save the changes] at the bottom.","wpinfecscan");?></p>
        <textarea style="width:100%;height:120px" id="ipblocksetting" name="ipblocksetting" placeholder="<?php _e("Example","wpinfecscan");?>&#10;111.222.333.444&#10;555.666.777.888"><?php echo get_option( 'wpinfectscanner_blockip'); ?></textarea>
         
        <hr>
        
        <h3><?php _e("Advanced blocking of hackers' IP","wpinfecscan");?></h3>
        <p><?php _e("When hackers attack your site, they check to see if the vulnerable files are present on your site　by actually accessing them. By detecting such access and immediately blocking the hacker's IP　for 24 hours, you can reduce the risk of hacking through the vulnerability.","wpinfecscan");?></p>
        <p><input type="checkbox" name="advanceblockip" onchange="selectautoipblock()" id="advanceblockip" value="1" <?php $advanceblockip = get_option("wpinfectscanner_advanceblockip");if($advanceblockip==1){ echo " checked='checked'";} ?>><?php _e("Enable advanced blocking features of the hacker's IP (Paid)","wpinfecscan");?></p>
        
        <?php 
        $advanceblockip = get_option("wpinfectscanner_advanceblockip");
            
        global $wpdb;
        $table_name = $wpdb->prefix . 'infectscannernfblock';
        if($wpdb->get_var("SHOW TABLES LIKE '".$table_name."'") == $table_name) {
            echo "<style>.datashow td{padding:3px;max-width:200px;word-break:break-all;} .datashow tr{border-top: 1px solid #ddd;}  .showq{word-break:break-all;max-width:200px !IMPORTANT;max-height:50px;overflow-x:auto;}</style>";
            
            $resi = $wpdb->get_results("SELECT * FROM `".$wpdb->prefix."infectscannernfblock` ORDER BY lastdetect DESC limit 50");
            
            if($resi){
                
                if($scanner->getpro()!=1){
                    echo "<div style='width:100%;max-height:200px;overflow:auto;padding:10px;border:1px solid #7e8993;box-sizing:border-box;'><p>".__("List of detected malicious accesses (displays up to 50)",'wpinfecscan')."</p><table style='width:100%' class='datashow'>
                    <tr>
                    <th>IP</th>
                    <th>".__("Access file",'wpinfecscan')."</th>
                    <th>".__("Detect time",'wpinfecscan')."</th>
                    <th>".__("Query",'wpinfecscan')."</th>
                    </tr>
                    ";
                    foreach( $resi as $key => $row) {
                        $ip = $row->ipv4;
                        if(empty($ip)){
                            $ip = $row->ipv6;
                        }
                        $accessedfile= $row->filepath.$row->filename;
                        $accessedfile=str_replace('//','/',$accessedfile);
                        $detecttime = get_date_from_gmt($row->lastdetect,"Y-m-d H:i:s");
                        
                        $getdata = $row->getquery;
                        $postdata = $row->postquery;
                        $showquery = $getdata;
                        if(strlen($postdata)>1){
                            $showquery = $postdata;
                        }
                        $showquery=str_replace('"','',$showquery);
                        $showquery=str_replace('{','',$showquery);
                        $showquery=str_replace('}','',$showquery);
                        $showquery=str_replace(':','=',$showquery);
                        $showquery = htmlspecialchars (mb_strimwidth($showquery, 0, 110, '...'));
                        
                        
                        echo "<tr><td>".$ip."</td><td>".$accessedfile."</td><td>".$detecttime."</td><td class='showq'>".$showquery."</td></tr>";
                    }
                    echo "</table></div>";
                    
                }else{
                     
                    if($advanceblockip==1){
                        echo "<div style='width:100%;max-height:200px;overflow:auto;padding:10px;border:1px solid #7e8993;box-sizing:border-box;'><p>".__("List of detected malicious accesses (displays up to 50)",'wpinfecscan')."</p><table style='width:100%' class='datashow'>
                        <tr>
                        <th>IP</th>
                        <th>".__("Access file",'wpinfecscan')."</th>
                        <th>".__("Detect time",'wpinfecscan')."</th>
                        <th>".__("Query",'wpinfecscan')."</th>
                        <th nowrap>".__("Block",'wpinfecscan')."</th>
                        <th nowrap>".__("Enable access",'wpinfecscan')."</th>
                        </tr>
                        ";
                        foreach( $resi as $key => $row) {
                            $ip = $row->ipv4;
                            if(empty($ip)){
                                $ip = $row->ipv6;
                            }
                            $accessedfile= $row->filepath.$row->filename;
                            $accessedfile=str_replace('//','/',$accessedfile);
                            $detecttime = get_date_from_gmt($row->lastdetect,"Y-m-d H:i:s");
                            
                            $blocktext = __("Block ended",'wpinfecscan');
                            $blockstop = '-';
                            
                            $getdata = $row->getquery;
                            $postdata = $row->postquery;
                            $showquery = $getdata;
                            if(strlen($postdata)>1){
                                $showquery = $postdata;
                            }
                            $showquery=str_replace('"','',$showquery);
                            $showquery=str_replace('{','',$showquery);
                            $showquery=str_replace('}','',$showquery);
                            $showquery=str_replace(':','=',$showquery);
                            $showquery = htmlspecialchars (mb_strimwidth($showquery, 0, 80, '...'));
                        
                            if(time()-strtotime($detecttime)<60*60*24){
                                $blocktext = "<b style='color:blue'>".__("Block",'wpinfecscan')."<b>";
                                $blockstop = "<button onClick=\"blockipstop(event,'".$ip."')\">".__("Enable access",'wpinfecscan')."</button>";
                            }
                            
                            echo "<tr><td>".$ip."</td><td>".$accessedfile."</td><td>".$detecttime."</td><td class='showq'>".$showquery."</td><td nowrap>".$blocktext."</td><td nowrap>".$blockstop."</td></tr>";
                        }
                        echo "</table></div> 
                        <script>
                        function blockipstop(e,bip){
                            e = e || window.event;
                            e.preventDefault();
                            
                            var result = window.confirm(bip+' ".__("Do you want to delete the record of this IP and unblock it?",'wpinfecscan')."');
                            if( result ) {
                                location.href = '".admin_url()."admin.php?page=wpdoctorinfecscanner&deladvanceip='+bip;
                            }
                            
                        }
                        </script>
                        ";
                    }else{
                        echo "<div style='width:100%;max-height:200px;overflow:auto;padding:10px;border:1px solid #7e8993;box-sizing:border-box;'><p>".__("List of detected malicious accesses (displays up to 50)",'wpinfecscan')."</p><table style='width:100%' class='datashow'>
                        <tr>
                        <th>IP</th>
                        <th>".__("Access file",'wpinfecscan')."</th>
                        <th>".__("Detect time",'wpinfecscan')."</th>
                        <th>".__("Query",'wpinfecscan')."</th>
                        </tr>
                        ";
                        foreach( $resi as $key => $row) {
                            $ip = $row->ipv4;
                            if(empty($ip)){
                                $ip = $row->ipv6;
                            }
                            $accessedfile= $row->filepath.$row->filename;
                            $accessedfile=str_replace('//','/',$accessedfile);
                            $detecttime = get_date_from_gmt($row->lastdetect,"Y-m-d H:i:s");
                            
                            $getdata = $row->getquery;
                            $postdata = $row->postquery;
                            $showquery = $getdata;
                            if(strlen($postdata)>1){
                                $showquery = $postdata;
                            }
                            $showquery=str_replace('"','',$showquery);
                            $showquery=str_replace('{','',$showquery);
                            $showquery=str_replace('}','',$showquery);
                            $showquery=str_replace(':','=',$showquery);
                            $showquery = htmlspecialchars (mb_strimwidth($showquery, 0, 110, '...'));
                            
                            
                            echo "<tr><td>".$ip."</td><td>".$accessedfile."</td><td>".$detecttime."</td><td class='showq'>".$showquery."</td></tr>";
                        }
                        echo "</table></div>";
                    }
                }
            }
        }
        
        ?>
        <hr>
        
        <h3><?php _e("IP map of active hackers","wpinfecscan");?></h3>
        <p><?php _e("These IPs are of hackers around the world detected daily by WordPress doctor. This data is updated every 24 hours.","wpinfecscan");?></p>
        <p><input type="checkbox" onchange="selectautoipblock()" name="autoblockip" id="ipblockcheckbox" value="1" <?php $autoblockipdata = get_option("wpinfectscanner_autoblockip");if(!empty($autoblockipdata )){ echo " checked='checked'";} ?>><?php _e("Block this IP automatically from access to the website (Paid)","wpinfecscan");?></p>
        <div id="container" class='infecmapper' style="position: relative;float:left; width: 650px; height: 400px;"></div>
        <div style="position: relative;float:left; width: 300px; height: 400px;">
        <script type="text/javascript" src="https://www.google.com/jsapi"></script>
        <div id="piechart"></div>
        <script type="text/javascript">
        google.load("visualization", "1", {packages:["corechart"]});
        google.setOnLoadCallback(drawChart);
        <?php
        $carray = array();
        foreach ($ipblockdata as $key => $value){
            $num =  1;
            if(!empty($carray[$value->country_name])){
                $num =  $carray[$value->country_name]+1;
            }
            $carray[$value->country_name] = $num;
        }
        $clarray = array();
        $clarray["Other"] = 0;
        foreach ($carray as $key => $value){
            if($value>4){
                $clarray[$key]=$value;
            }else{
                $clarray["Other"]+=$value;
            }
        }
        ?>
        function drawChart() {
            var data = google.visualization.arrayToDataTable([ //グラフデータの指定
                ['Country', 'detect ip count'],
                <?php 
                foreach ($clarray as $key => $value){
                    echo "['".$key."',     ".$value."],";
                }
                ?>
            ]);
            data.sort([{column: 1}]);
            var options = {
                       'width': 300,
                       'height': 400,
                       'chartArea': {'width': '90%', 'height': '55%'},
                       'pieSliceText': 'label',
                       'legend': {'position': 'none'}
            };
            var chart = new google.visualization.PieChart(document.getElementById('piechart')); //グラフを表示させる要素の指定
            chart.draw(data, options);
        }
        </script>
        </div>
        <div style="max-height:400px;overflow:auto;width:100%">
        <table class="table">
        <tr><td><?php _e("Hacker's IP</td><td>country, region","wpinfecscan");?></td></tr>
        <?php
            $autoipblockok = true;
            if($scanner->getpro()!=1){
                $autoipblockok = false;
            }
            $flagurl = plugin_dir_url( __FILE__ ).'images/worldicon/';
            if(!empty($ipblockdata)){
                foreach ($ipblockdata as $key => $value){
                    echo "<tr><td>".$value->ip."</td><td><img src='".$flagurl.strtoupper ($value->country).".png'> ".$value->country_name." ,".$value->city."</td></tr>";
                }
            }
        ?>
        </table>
        </div>
        <?php submit_button(); ?>
        </form>
        <script>
        var showmap = false;
        function mapview(){
            if (showmap==false){
                var bubble_map = new Datamap({
                  element: document.getElementById("container"),
                  geographyConfig: {
                    popupOnHover: false,
                    highlightOnHover: false
                  },
                  fills: {
                    defaultFill: '#ABDDA4',
                    dot: '#FF0000'
                  }
                });
                bubble_map.bubbles([
                <?php
                if(!empty($ipblockdata) ){
                    $count=0;
                    foreach ($ipblockdata as $key => $value){ 
                    if(!empty($value->latitude) && !empty($value->longitude)) {
                    ?>
                      {
                        name: '<?php echo $value->country_name."(".$value->city.")"; ?>',
                        radius: 7,
                        country: '<?php echo $value->country; ?>',
                        latitude: <?php echo $value->latitude; ?>,
                        longitude: <?php echo $value->longitude; ?>,
                        fillKey: 'dot',
                        yeild: 1,
                      },
                    <?php $count++;if($count>200){break;}}}} ?>
                ], {
                  popupTemplate: function(geo, data) {
                    return '<div class="hoverinfo">' + data.name + '</div>'
                  }
                });
                showmap=true;
            }
        }
        function selectautoipblock(){
            <?php if($autoipblockok==false){ ?>
            if(document.getElementById("ipblockcheckbox").checked  || document.getElementById("advanceblockip").checked){
                alert("<?php _e("This function is exclusive for subscription (paid) members of malware.","wpinfecscan");?>");
                document.getElementById("ipblockcheckbox").checked = false;
                document.getElementById("advanceblockip").checked = false;
            }
            <?php } ?>
        }
        </script>
    </div>
</div>